#ifndef BatchLab_Calculator_h
#define BatchLab_Calculator_h

#include <vector>
#include <string>

#include <Lib/Value.h>

namespace Lib {class Processor;}

namespace Slash {namespace Core {class IWriter;}}

namespace AIDA {class ITree;}
namespace AIDA {class ITuple;}

namespace BatchLab {class BaseTuple;}
namespace BatchLab {class BaseColumn;}

namespace BatchLab {

class Calculator {
public:
  //virtual const std::string& label() const;
  Calculator(Slash::Core::IWriter&,const std::string&,AIDA::ITree&);
  virtual ~Calculator();
protected:
  Calculator(const Calculator&);
  Calculator& operator=(const Calculator&);
protected:
  bool initialize(AIDA::ITuple&);
  bool getVariables();
  Slash::Core::IWriter& fPrinter;
private:
  AIDA::ITree& fTree; //to find functions.
  const AIDA::ITuple* fTuple;
  std::vector<std::string> fNames;
  std::vector<int> fIndices;
  // To optimize :
  const BatchLab::BaseTuple* fBaseTuple;  
  std::vector<BatchLab::BaseColumn*> fBaseCols;
protected:
  Lib::Processor* fProcessor;
  std::string fScript;
  std::vector<Lib::Value> fVals;
  Lib::Value fResult;
};

}

#endif
