#ifndef BatchLab_Folder_h
#define BatchLab_Folder_h

// Inheritance :
#include <BatchLab/Core/BaseFolder.h>

namespace BatchLab {

class Folder : public BaseFolder {
public: //Slash::Store::IFolder
  virtual void* cast(const std::string&) const;
  virtual void add(Slash::Store::IObject*);
  virtual void remove(Slash::Store::IObject*);
  virtual void add(Slash::Store::IFolder*);
  virtual void remove(Slash::Store::IFolder*);
  virtual bool link(Slash::Store::IFolder*,const std::string&);
  virtual bool unlink(Slash::Store::IFolder*);
  virtual void clear();
  virtual Slash::Store::IFolder* mkdir(const std::string&);
  virtual Slash::Store::IObjectIterator* objects() const;
  virtual Slash::Store::IFolderIterator* folders() const;
public:
  Folder(Slash::Core::IWriter&,Slash::Store::IFolder*,const std::string&,Slash::Store::ITree&);
  virtual ~Folder();
private:
  std::list<Slash::Store::IFolder*> fFolders;
  std::list<Slash::Store::IObject*> fObjects;
};

}

#endif
