#ifndef Lib_LibraryManager_h
#define Lib_LibraryManager_h

// Inheritance :
#include <Slash/Core/ILibrary.h>
#include <Slash/Core/IManager.h>
#include <Slash/Core/ILibraryManager.h>

#include <list>

namespace Slash {namespace Core {class ISession;}}

namespace Lib {

class DLL;

class Library : public virtual Slash::Core::ILibrary {
public: // Slash::Core::ILibrary :
  virtual std::string name() const;
  virtual bool isInitialized() const;
  virtual Slash::Core::ILibrary::Procedure findProcedure(const std::string&,bool = false) const;
public:
  Library(Slash::Core::ISession&,
          const std::string&,
          const std::string&,
          const std::string&,
          bool = false);
  virtual ~Library();
  const std::string& package() const;
  bool execute(const std::string&) const;
private:
  Slash::Core::ISession& fSession;
  std::string fName;
  std::string fLibrary;
  std::string fPackage;
  DLL* fDLL;
};

class LibraryManager
:public virtual Slash::Core::IManager 
,public virtual Slash::Core::ILibraryManager 
{
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public: //Slash::Core::ILibraryManager
  virtual Slash::Core::ILibrary* addLibrary(const std::string&,
                               const std::string&,
                               const std::string&,
                               bool = false);
  virtual Slash::Core::ILibrary* findLibrary(const std::string&);
public:
  LibraryManager(Slash::Core::ISession&);
  virtual ~LibraryManager();
private:
  Slash::Core::ISession& fSession;
  std::string fName;
  std::list<Slash::Core::ILibrary*> fList;
};

}

#endif




